%global gem_name occi-server
%global app_root %{_datadir}/%{name}
%global semodule_name rocci_server

%global commit e142d83fc4214fdfd7498209e68491eb913cd1cf
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global date 20140830

Name:           rOCCI-server
Version:        1.0.5
Release:        0.%{date}git%{shortcommit}%{?dist}.3
Summary:        Ruby OCCI Server

License:        ASL 2.0
URL:            https://github.com/EGI-FCTF/rOCCI-server
Source0:        https://github.com/EGI-FCTF/%{name}/archive/%{commit}/%{name}-%{commit}.tar.gz
Source1:        %{semodule_name}.te
Source2:        %{semodule_name}.fc
Source3:        %{name}.logrotate
Source4:        README.Fedora
Source5:        %{name}.target
# kill bundler
# (not intended for upstream)
Patch0:         rocci-server-unbundle.diff
# missing requires in code (needed when bundler is not used)
Patch1:         rocci-server-requires.diff

BuildArch:      noarch
BuildRequires:  policycoreutils-python
BuildRequires:  ruby(release) >= 1.9.3
BuildRequires:  rubygems-devel
BuildRequires:  rubygem(rdoc)
BuildRequires:  systemd
# tests (plus all runtimes)
#BuildRequires:  rubygem(rspec)
#BuildRequires:  rubygem(rspec-rails)
Requires(pre):  shadow-utils
Requires(post): policycoreutils
Requires(post): systemd
Requires(preun): policycoreutils
Requires(preun): systemd
Requires(postun): policycoreutils
Requires(postun): systemd
Requires:       logrotate
Requires:       memcached
Requires:       mod_passenger
Requires:       rubygem(dalli)
Requires:       rubygem(hashie)
Requires:       rubygem(ice_nine)
# upstream: jbuilder ~> 2.1.0
# F20: 1.5.0
Requires:       rubygem(jbuilder)
Requires:       rubygem(kgio)
# upstream: ~> 4.0.48
# F20: 4.0.18
Requires:       rubygem(passenger)
# upstream: rails ~> 4.0.8
# F20: 4.0.0, F21: 4.1.x
Requires:       rubygem(rails) >= 4.0.0
Requires:       rubygem(rails) <= 4.1
# upstream: rails-api ~> 0.2.0, F20: 0.1.0
Requires:       rubygem(rails-api)
# COPR
Requires:       rubygem(logstasher)
Requires:       rubygem(occi-core) >= 4.2.16
Requires:       rubygem(occi-core) < 4.3
Requires:       rubygem(rack-cors)
Requires:       rubygem(whenever)
# upstream: >= 1.2.3, really needed
# F20: 1.2.0
Requires:       rubygem(warden) >= 1.2.3
%if 0%{?fedora} && 0%{?fedora} <= 20 || 0%{?rhel} && 0%{?rhel} <= 7
Requires:       ruby(release)
Requires:       ruby(rubygems)
Requires:       rubygem(openssl_cms_2_0_0)
Provides:       rubygem(%{gem_name}) = %{version}
%else
Requires:       rubygem(openssl_cms_2_1)
%endif

%description
OCCI (the Open Cloud Computing Interface) is a standard by the Open Grid Forum,
specifying a protocol and API to perform various remote management tasks in
clouds. The rOCCI-server extends cloud managers, which are not OCCI-compliant
natively, with its own OCCI interface. It is based on the rOCCI (Ruby OCCI)
Framework.


%package doc
Summary:        Documentation for %{name}
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
Documentation for %{name}.


%package ec2
Summary:        Amazon backend for %{gem_name}
BuildArch:      noarch
Requires:       rubygem(aws-sdk-core) >= 2.0.0.rc15
Requires:       rubygem(aws-sdk-core) < 2.0.1
Requires:       %{name} = %{version}-%{release}

%description ec2
OCCI (the Open Cloud Computing Interface) is a standard by the Open Grid Forum,
specifying a protocol and API to perform various remote management tasks in
clouds. The rOCCI-server extends cloud managers, which are not OCCI-compliant
natively, with its own OCCI interface. It is based on the rOCCI (Ruby OCCI)
Framework.

This package provides Amazon Web Services backend for OCCI server.


%package opennebula
Summary:        Opennebula backend for %{gem_name}
BuildArch:      noarch
Requires:       rubygem(erubis)
# upstream: opennebula ~> 4.6.0
# current: opennebula 4.8.0
Requires:       rubygem(opennebula) >= 4.6.0
#Requires:       rubygem(opennebula) < 4.7
Requires:       rubygem(ox)
Requires:       %{name} = %{version}-%{release}

%description opennebula
OCCI (the Open Cloud Computing Interface) is a standard by the Open Grid Forum,
specifying a protocol and API to perform various remote management tasks in
clouds. The rOCCI-server extends cloud managers, which are not OCCI-compliant
natively, with its own OCCI interface. It is based on the rOCCI (Ruby OCCI)
Framework.

This package provides Opennebula backend for OCCI server.


%prep
%setup -q -n %{name}-%{commit}

# kill bundler
%patch0 -p1
%patch1 -p1
mv Gemfile Gemfile.unused
mv Gemfile.lock Gemfile.lock.unused

# apache >= 2.4 syntax, applicaton prefix
sed -i examples/etc/apache2/sites-available/occi-ssl \
  -e 's/Allow from all/Require all granted/i' \
  -e 's,/opt/rOCCI-server,%{app_root},g'

# fix interpreter
sed -i examples/usr/local/bin/check_occi_compute_create \
  -e '1s,#!/opt/occi-cli/embedded/bin/ruby,#!/usr/bin/env ruby,'


%build
checkmodule -M -m -o %{semodule_name}.mod %{SOURCE1}
semodule_package -o %{semodule_name}.pp -m %{semodule_name}.mod -f %{SOURCE2}


%install
mkdir -p %{buildroot}%{app_root}
mkdir -p %{buildroot}%{_sysconfdir}
cp -a . %{buildroot}%{app_root}

# unused files
rm -f %{buildroot}%{app_root}/.gitignore
find %{buildroot}%{app_root} -name .keep -delete

# configuration files
mv %{buildroot}%{app_root}/etc %{buildroot}%{_sysconfdir}/rocci-server
ln -s %{_sysconfdir}/rocci-server %{buildroot}%{app_root}/etc

# logs
mkdir -p %{buildroot}%{_localstatedir}/log/rocci-server
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
rm -rf %{buildroot}/%{app_root}/log
ln -s %{_localstatedir}/log/rocci-server %{buildroot}/%{app_root}/log
install -p -m 0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

rdoc --op %{buildroot}%{_pkgdocdir} lib app *.md
# fix permissions (but it conflicts with COPR buildsystem for F21+)
%if 0%{?fedora} && 0%{?fedora} <= 20 || 0%{?rhel} && 0%{?rhel} <= 7
chmod -x %{buildroot}%{_pkgdocdir}/images/*.png
%endif

install -p -m 0644 %{SOURCE4} %{buildroot}%{_pkgdocdir}

# SELinux
mkdir -p %{buildroot}%{_datadir}/selinux/packages/%{name}
install -m 0644 %{semodule_name}.pp %{buildroot}%{_datadir}/selinux/packages/%{name}
rm -f %{buildroot}%{app_root}/%{semodule_name}.mod
rm -f %{buildroot}%{app_root}/%{semodule_name}.pp

# httpd configuration tweaks
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
install -p -m 0644 examples/etc/apache2/sites-available/occi-ssl %{buildroot}%{_sysconfdir}/httpd/conf.d/occi-ssl.conf
echo "Listen 11443" >>  %{buildroot}%{_sysconfdir}/httpd/conf.d/occi-listen.conf
install -p -m 0644 examples/etc/apache2/conf.d/security %{buildroot}%{_sysconfdir}/httpd/conf.d/occi-security.conf

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE5} %{buildroot}%{_unitdir}

# Upstream testsuite fails:
#254 examples, 29 failures, 13 pending
#%%check
#rspec -Ilib spec --require spec_helper


%pre
getent group rocci >/dev/null || groupadd -r rocci
getent passwd rocci >/dev/null || useradd -r -g rocci -d %{app_root} -c "rOCCI user" rocci

%post
if [ "$1" -le "1" ] ; then # First install
  semodule -i %{_datadir}/selinux/packages/%{name}/%{semodule_name}.pp 2>/dev/null || :
  restorecon -R %{app_root} %{_localstatedir}/log/rocci-server 2>/dev/null || :
  semanage port -a -t http_port_t -p tcp 11443 2>/dev/null || :
fi
%systemd_post %{name}.target

%preun
if [ "$1" -lt "1" ] ; then # Final removal
  semodule -r %{semodule_name} 2>/dev/null || :
  semanage port -d -t http_port_t -p tcp 11443 2>/dev/null || :
fi
%systemd_preun %{name}.target

%postun
if [ "$1" -ge "1" ] ; then # Upgrade
  semodule -i %{_datadir}/selinux/packages/%{name}/%{semodule_name}.pp 2>/dev/null || :
  restorecon -R %{app_root} %{_localstatedir}/log/rocci-server 2>/dev/null || :
fi
# rOCCI-server.target doesn't support restarting, use httpd instead
%systemd_postun httpd.service


%files
%doc %{_pkgdocdir}/README.Fedora
%doc %{app_root}/LICENSE
%config(noreplace) %{_sysconfdir}/rocci-server/
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/occi-listen.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/occi-security.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/occi-ssl.conf
%dir %{_datadir}/selinux/packages/%{name}/
%dir %{app_root}/
%dir %{app_root}/lib/backends/
%{app_root}/app/
%{app_root}/config/
%{app_root}/db/
%{app_root}/examples/
%{app_root}/lib/assets/
%{app_root}/lib/authentication_strategies
%{app_root}/lib/backends/dummy/
%{app_root}/lib/backends/errors/
%{app_root}/lib/backends/helpers/
%{app_root}/lib/backends/dummy_backend.rb
%{app_root}/lib/errors/
%{app_root}/lib/hooks/
%{app_root}/lib/request_parsers/
%{app_root}/lib/tasks
%{app_root}/public/
%{app_root}/vendor/
%{app_root}/etc
%{app_root}/log
%{app_root}/Capfile
%{app_root}/config.ru
%attr(-,rocci,rocci) %{_localstatedir}/log/rocci-server/
%{_datadir}/selinux/packages/%{name}/%{semodule_name}.pp
%{_unitdir}/%{name}.target
%exclude %{app_root}/bin/
%exclude %{app_root}/.bundle/
%exclude %{app_root}/.rspec
%exclude %{app_root}/.travis.yml
%exclude %{app_root}/Guardfile
%exclude %{_pkgdocdir}/

%files doc
%{_pkgdocdir}/
%{app_root}/lib/backends/bundles/
%{app_root}/spec/
%{app_root}/test/
%{app_root}/Gemfile.unused
%{app_root}/Gemfile.lock.unused
%{app_root}/README.md
%{app_root}/Rakefile

%files ec2
%{app_root}/lib/backends/ec2/
%{app_root}/lib/backends/ec2_backend.rb

%files opennebula
%{app_root}/lib/backends/opennebula/
%{app_root}/lib/backends/opennebula_backend.rb


%changelog
* Sun Sep 14 2014 František Dvořák <valtri@civ.zcu.cz> - 1.0.5-0.20140830gite142d83.3
- Initial package
